<template>
  <div>
    <v-card>
      <v-toolbar color="grey" dark>
        <v-toolbar-title class="white--text">
          LISTA DE PERFILES DE LA PLATAFORMA
          <v-tooltip bottom>
            <template v-slot:activator="{ on, attrs }">
              <v-btn
                fab
                class="white--text"
                color="primary"
                bottom
                right
                v-bind="attrs"
                v-on="on"
                absolute
                :to="{ name: 'accesos_perfiles_nuevo' }"
              >
                <v-icon>mdi-plus</v-icon>
              </v-btn>
            </template>
            <span>Nuevo perfil</span>
          </v-tooltip>
        </v-toolbar-title>
        <v-spacer></v-spacer>
        <v-text-field
          v-model="search"
          label="Buscar"
          flat
          class="mr-16"
          dark
          solo-inverted
          append-icon="mdi-magnify"
          hide-details
          clear-icon="mdi-close-circle-outline"
        ></v-text-field>
      </v-toolbar>
      <v-list three-line subheader>
        <v-subheader>
          <v-badge
            color="grey"
            dark
            inline
            :value="searchResult.length"
            :content="searchResult.length"
          >
            <span class="pt-2">PERFILES</span>
          </v-badge>
        </v-subheader>
        <v-list-item-group
          v-model="selectedItem"
          style="overflow: auto;max-height:500px; min-height:500px"
          color="primary"
        >
          <v-divider />
          <template v-for="(item, indexItem) in searchResult">
            <v-list-item :key="indexItem" link>
              <v-list-item-avatar>
                <v-icon color="grey lighten-1" x-large
                  >mdi-account-group-outline</v-icon
                >
              </v-list-item-avatar>
              <v-list-item-content>
                <v-list-item-title>
                  <router-link
                    class="text-decoration-underline"
                    :to="toEditPerfil(item)"
                  >
                    {{ item.descripcion }}
                  </router-link>
                </v-list-item-title>
                <v-list-item-subtitle>
                  <v-badge
                    color="primary"
                    inline
                    overlap
                    :value="item.totalVistas"
                    :content="item.totalVistas"
                  >
                    <v-icon color="grey lighten-1"
                      >mdi-file-document-multiple-outline</v-icon
                    >
                    <router-link
                      class="text-decoration-underline"
                      :to="toPerfilVistas(item)"
                    >
                      Vistas
                    </router-link>
                  </v-badge>
                </v-list-item-subtitle>
                <v-list-item-subtitle>
                  <v-badge
                    color="primary"
                    inline
                    overlap
                    :value="item.totalUsuariosFijos"
                    :content="item.totalUsuariosFijos"
                  >
                    <v-icon color="grey lighten-1">
                      mdi-account-multiple-outline
                    </v-icon>
                    <router-link
                      class="text-decoration-underline"
                      :to="toPerfilUsuariosFijos(item)"
                    >
                      Usuarios Fijos
                    </router-link>
                  </v-badge>
                </v-list-item-subtitle>
                <v-list-item-subtitle>
                  <v-badge
                    color="primary"
                    inline
                    overlap
                    :value="item.totalUsuarios"
                    :content="item.totalUsuarios"
                  >
                    <v-icon color="grey lighten-1">
                      mdi-account-multiple-outline
                    </v-icon>
                    <router-link
                      class="text-decoration-underline"
                      :to="toPerfilUsuarios(item)"
                    >
                      Usuarios
                    </router-link>
                  </v-badge>
                </v-list-item-subtitle>
              </v-list-item-content>
              <v-list-item-action>
                <v-tooltip bottom>
                  <template v-slot:activator="{ on, attrs }">
                    <v-btn
                      class="white--text"
                      v-bind="attrs"
                      v-on="on"
                      fab
                      small
                      color="primary"
                      @click="deletePerfil(item)"
                    >
                      <v-icon>mdi-delete</v-icon>
                    </v-btn>
                  </template>
                  <span>Borrar perfil</span>
                </v-tooltip>
              </v-list-item-action>
            </v-list-item>
            <v-divider :key="'divider-' + indexItem" />
          </template>
        </v-list-item-group>
      </v-list>
    </v-card>
  </div>
</template>
<style scoped>
.publicado--text {
  color: #4fd495;
}
.revisar--text {
  color: #fdae31;
}
.autorizar--text {
  color: #feb94b;
}
.documentar--text {
  color: #fad743;
}
.link {
  text-decoration: underline;
  color: black;
  cursor: pointer;
}
.float-rigth.v-btn {
  float: right;
}
.float-left {
  float: left;
}
</style>
<style>
.custom-speed-dial.v-speed-dial--direction-left .v-speed-dial__list {
  right: 60%;
}
.theme--light.v-data-table.v-data-table--fixed-header thead {
  border-bottom: #ffcd00 3px solid;
}
.theme--light.v-data-table.v-data-table--fixed-header thead th {
  background-color: #fafafa;
}
div.custom-table div table tbody tr:nth-child(odd) {
  background-color: #fafafa;
}
div.custom-table div table tbody tr:nth-child(even) {
  background-color: #f0f0f0;
}
div.custom-table div table tbody tr:hover {
  background-color: #ffcd0059 !important;
}
div.custom-table .t-footer {
  background-color: #fafafa;
}
.v-data-table.custom-table.theme--light.v-data-table {
  background-color: #fafafa;
}
</style>
<script>
import store from "@/store";
const serviceCommons = store.state.serviceCommons;
const axios = store.state.axiosApiLocal;
export default {
  name: "Component-ListaPerfiles",
  data: (vm) => ({
    data: [],
    loading: false,
    caseSensitive: false,
    search: null,
    selectedItem: null,
  }),
  computed: {
    serviceCommons() {
      return serviceCommons;
    },
    searchResult() {
      let tempData = this.data;
      if (this.search != "" && this.search) {
        tempData = tempData.filter((item) => {
          return item.descripcion
            .toUpperCase()
            .includes(this.search.toUpperCase());
        });
      }
      if (tempData.length > 0) {
        tempData = tempData.sort((a, b) => {
          let fa = a.descripcion.toLowerCase();
          let fb = b.descripcion.toLowerCase();
          if (fa < fb) {
            return -1;
          }
          if (fa > fb) {
            return 1;
          }
          return 0;
        });
      }
      return tempData;
    },
  },
  methods: {
    toEditPerfil(perfil) {
      return {
        name: "accesos_perfiles_edicion",
        params: {
          perfil: this.serviceCommons.objectToBase64(perfil),
        },
      };
    },
    toPerfilVistas(perfil) {
      return {
        name: "accesos_perfiles_edicion",
        params: {
          perfil: this.serviceCommons.objectToBase64(perfil),
        },
        query: {
          vistas: this.serviceCommons.objectToBase64({}),
        },
      };
    },
    toPerfilUsuariosFijos(perfil) {
      return {
        name: "accesos_perfiles_edicion",
        params: {
          perfil: this.serviceCommons.objectToBase64(perfil),
        },
        query: {
          usuarios_fijos: this.serviceCommons.objectToBase64({}),
        },
      };
    },
    toPerfilUsuarios(perfil) {
      return {
        name: "accesos_perfiles_edicion",
        params: {
          perfil: this.serviceCommons.objectToBase64(perfil),
        },
        query: {
          usuarios: this.serviceCommons.objectToBase64({}),
        },
      };
    },
    deletePerfil(perfil) {
      axios
        .delete("/accesos/sistema/perfiles/v1/" + perfil.idPerfil)
        .then((response) => {
          this.getPerfiles();
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        });
    },
    getUsuariosPerfil(perfil) {
      axios("/accesos/sistema/usuarios/v1/perfiles/" + perfil.idPerfil)
        .then((response) => {
          let data = response.data;
          if (data) {
            perfil.totalUsuarios = data.resultado.usuarios.length;
          }
        })
        .catch((error) => {});
    },
    getUsuariosFijosPerfil(perfil) {
      axios(
        "/accesos/sistema/usuarios/v1/perfiles/" + perfil.idPerfil + "/fijos"
      )
        .then((response) => {
          let data = response.data;
          if (data) {
            perfil.totalUsuariosFijos = data.resultado.usuarios.length;
          }
        })
        .catch((error) => {});
    },
    getVistasPerfil(perfil) {
      axios("/accesos/sistema/vistas/v1/perfiles/" + perfil.idPerfil)
        .then((response) => {
          let data = response.data;
          if (data) {
            perfil.totalVistas = data.resultado.vistas.length;
          }
        })
        .catch((error) => {});
    },
    getPerfiles() {
      const self = this;
      this.loading = true;
      axios("/accesos/sistema/perfiles/v1/")
        .then((response) => {
          let data = response.data;
          if (data) {
            data.resultado.perfiles = data.resultado.perfiles.map((perfil) => {
              perfil.totalVistas = null;
              perfil.totalUsuariosFijos = null;
              perfil.totalUsuarios = null;
              return perfil;
            });
            this.data = data.resultado.perfiles;
            this.data.forEach((perfil) => {
              this.getVistasPerfil(perfil);
              this.getUsuariosFijosPerfil(perfil);
              this.getUsuariosPerfil(perfil);
            });
          }
        })
        .catch((error) => {
          if (error.response && error.response.status == 404) {
            this.data = [];
          } else {
            console.log(error);
          }
        })
        .finally(() => {
          self.loading = false;
        });
    },
  },
  created() {
    this.getPerfiles();
  },
};
</script>
